	;include "tios.h"
	include "doorsos.h"
	
	xdef _library
	xdef _ti89
	xdef _ti92plus
	xdef polysnd@0000
	xdef polysnd@0001
	
polysnd@0000:
	;Sauvegarde des registres...
	movem.l	d0/d1/d3-d7/a0/a3,-(a7)
	bsr	GetCalculator
	bsr	GetHardware
	
	cmp.w	#1,Hardware
	bne	PlaySound1
	muls	#10,d2				;Adaptation du HW2 sur HW1	12 Mhz, 10 Mhz
	divs	#12,d2				;Est qui vaut  1.2	

PlaySound1:
	;Enregistre les donnes
	move.w	#0,tps1
	move.w	#0,tps2
	move.w	d2,unittps
	clr.l	d0
	
	;move.w	#$700,d0			;Dplace le chiffre 1792 pour
	;trap	#1				;dsactiver l'auto-interruption n1
	;move.w	d0,-(sp)			;Enregistre l'handle de int1 dans d0
	
	lea	TblFreq(PC),a0			;Charge la liste des frquences dans a0
	;lea 	morc1(PC),a1			;Charge les donnes du morceau 1 dans a1
	;lea	morc2(PC),a2			;Charge les donnes du morceau 2 dans a2
	
	bset	#6,($60000C)			;Initialise le port IO soit le byte 6 mie  1
	bclr	#0,($60000E)			;Initialise l'couteur gauche
	bclr	#1,($60000E)			;Initialise l'couteur droit
	
	move.b	#1,duree1			;Initialize duree1  1
	move.b	#1,duree2		 	;Initialize duree2  2
	
boucle1:
	sub.b	#1,duree1			;soutrait 1  duree1
	cmp.b	#0,duree1			;Si duree1!=0 alors
	bne	cont_11				;aller  cont_1
	
;charge1
;touche [ESC] enfonc ?
	cmp	#0,calc				;Si TI-89
	beq	key_891				;Aller  key_89
	bne	key_921				;sinon key_92

key_891: move.w	#6,d0				;Sur TI-89, detection touche [ESC]
	bsr	masque				;Clavier en bas niveau
	btst.b	#0,d0
	beq	fin1
	bne	suite1

key_921: move.w	#8,d0				;dplace 8 dans d0
	bsr	masque				;Va  masque pour lire en bas niveau le clavier
	btst.b	#6,d0				;Teste le bit 6 du clavier
	beq	fin1				;Si le bit 6 est  1 soit touche ESC press alors aller  fin
	
suite1:	cmp.b	#255,(a1)			;Vrifie si dans le morceau en cours si il y a 255 soit 0hFF 
	beq	fin1				;255=end;alors aller  fin
	clr.l	d0				;Efface le registre d0
	;clr.b	d2
	
	move.b	(a1)+,d0			;frquence dans d0
	move.b	(a1)+,d2			;longueur dans d2
	move.b	#1,d1				;Dplace 1 dans d1 (d1 tmoin  1)
	bsr	decode1				;Va au dcodage des notes
	move.w	tps1,d7				;dure crneau 1
;en opposition de polarit avec 2

	btst	#1,($60000E)			;Vrifie si le bit 1 est  1
	bne	plus11				;Si 1 alors aller  plus1
	bclr	#0,($60000E)			;Initialize couteur gauche
	bra	cont_11				;Va  cont_1

plus11:
	bset	#0,($60000E)			;Met  1 le bit 0 de l'couteur gauche

cont_11:
	sub.b	#1,duree2			;Soustrait de 1 duree2
	cmp.b	#0,duree2			;Si duree2!=0
	bne	cont_21				;alors aller  cont_2
;charge2
	cmp.b	#255,(a2)			;De mme pour morceau 2
	beq	fin1			;255=fin
	clr.l	d0
	;clr.b	d2
	
	move.b	(a2)+,d0		;frquence
	move.b	(a2)+,d2		;longueur
	move.b	#2,d1
	bsr	decode1
	move.w	tps2,d6
;en opposition de polarit avec 1
	btst	#0,($60000E)
	bne	plus21
	bclr	#1,($60000E)
	bra	cont_21

plus21:
	bset	#1,($60000E)
	
cont_21:
	move.w	unittps,d4
	
;cas d'une pause
	cmp.w	tps1,d4
	bhi	paspause11
	move.w	tps1,d7

paspause11:
	cmp.w	tps2,d4
	bhi	paspause21
	move.w	tps2,d6

paspause21:
	
;joue le son pendant une dure lmentaire
bcle_son1:
	dbra.w	d7,son_11
	move.w	tps1,d7
	bchg	#0,($60000E)
	
son_11:
	dbra.w	d6,son_21
	move.w	tps2,d6
	bchg	#1,($60000E)

son_21:
	dbra	d4,bcle_son1
	bra	boucle1
	

fin1:
	bclr	#0,($60000E)
	bclr	#1,($60000E)
	move.b	#$8D,($60000C)
	
	;move.w	(sp)+,d0
	;trap	#1
	movem.l	(a7)+,d0/d1/d3-d7/a0/a3
	rts
	
;******************************************************************
;Decode une valeur de note
;------------------------------------------------------------------
;d0=valeur code (1er chiffre hexa=octave,2me=note)
;d1=voie (1 ou 2)
;d2=dure
; =>d0=frquence
;******************************************************************

decode1:
	move.l	d1,-(a7)
	cmp.w	#0,d0
	beq	_pause1
	
	move.l	d0,d1
	ror.l	#4,d1
	
	sub.w	#1,d1
	mulu.w	#12,d1
	and.w	#$0f,d0
	sub.w	#1,d0
	add.w	d1,d0
	
	rol.l	#1,d0
	move.l	a0,a3
	
	add.w	d0,a3
	clr.l	d0
	move.w	(a3),d0
	bra	_stoc1

_pause1:
	move.w	unittps,d0
	add.w	#1,d0

_stoc1:
	move.l	(a7)+,d1
	cmp.b	#1,d1
	bne 	_stoc21
	move.w	d0,tps1
	move.b	d2,duree1
	
	;;-----------------------
	;;Affiche frquence voie1
	;;-----------------------
	;move.w	d0,d5
	;move.l	#2,d1
	;move.l	#1,d2
	;move.l	#3,d4
	;jsr	hexlib::put_hex
	;move.w	d5,d0
	
	
	;;-------------------
	;;Affiche dure voie1
	;;-------------------
	;move.b	duree1,d0
	;move.l	#4,d1
	;move.l	#1,d2
	;move.l	#3,d4
	;jsr	hexlib::put_hex

	rts

_stoc21:
	move.w	d0,tps2
	move.b	d2,duree2
	
	;;-----------------------
	;;Affiche frquence voie2
	;;-----------------------
	;move.w	d0,d5
	;move.l	#3,d1
	;move.l	#1,d2
	;move.l	#3,d4
	;jsr	hexlib::put_hex
	;move.w	d5,d0
	
	
	;;-------------------
	;;Affiche dure voie2
	;;--------------------
	;move.b	duree2,d0
	;move.l	#5,d1
	;move.l	#1,d2
	;move.l	#3,d4
	;jsr	hexlib::put_hex
	rts


;**************************************************************************************************************
;Play4Channel
;***************************************************************************************************************	
polysnd@0001:
	;Sauvegarde des registres...
	movem.l	d0/d1/d3-d7/a0/a5,-(a7)
	
	bsr	GetCalculator
	bsr	GetHardware
	
	cmp.w	#1,Hardware
	bne	PlaySound2
	muls	#10,d2				;Adaptation du HW2 sur HW1	12 Mhz, 10 Mhz
	divs	#12,d2				;Est qui vaut  1.2	

PlaySound2:
	;Enregistre les donnes
	move.w	#0,tps1
	move.w	#0,tps2
	move.w	#0,tps3
	move.w	#0,tps4
	
	muls	#30,d2				;Correspond  une				;Etalonnage de la boucle tempo
	divs	#51,d2				;division
		
	move.w	d2,unittps
	clr.l	d0
	
	;move.w	#$700,d0			;Dplace le chiffre 1792 pour
	;trap	#1				;dsactiver l'auto-interruption n1
	;move.w	d0,-(sp)			;Enregistre l'handle de int1 dans d0
	
	lea	TblFreq(PC),a0			;Charge la liste des frquences dans a0
	;lea 	morc1(PC),a1			;Charge les donnes du morceau 1 dans a1
	;lea	morc2(PC),a2			;Charge les donnes du morceau 2 dans a2
	
	bset	#6,($60000C)			;Initialise le port IO soit le byte 6 mie  1
	bclr	#0,($60000E)			;Initialise l'couteur gauche
	bclr	#1,($60000E)			;Initialise l'couteur droit
	
	move.b	#1,duree1			;Initialize duree1  1
	move.b	#1,duree2		 	;Initialize duree2  2
	move.b	#1,duree3			;Initialize duree3				;""
	move.b	#1,duree4			;Initialize duree4				;""
	
boucle2:
	
;charge1
;touche [ESC] enfonc ?
	cmp	#0,calc				;Si TI-89
	beq	key_892				;Aller  key_89
	bne	key_922				;sinon key_92

key_892: move.w	#6,d0				;Sur TI-89, detection touche [ESC]
	bsr	masque				;Clavier en bas niveau
	btst.b	#0,d0
	beq	fin2
	bne	suite2

key_922: move.w	#8,d0				;dplace 8 dans d0
	bsr	masque				;Va  masque pour lire en bas niveau le clavier
	btst.b	#6,d0				;Teste le bit 6 du clavier
	beq	fin2				;Si le bit 6 est  1 soit touche ESC press alors aller  fin
	
;----------------------
	sub.b	#1,duree1
	cmp.b	#0,duree1				;Si duree1!=0 alors
	bne	cont_12					;aller  cont_1
	
suite2:	cmp.b	#255,(a1)				;Si channel1=255 Fin			
	beq	fin2				
	clr.l	d0					;Efface Int1 sav
	move.b	(a1)+,d0				;Frquence	channel1
	move.b	(a1)+,d2				;Dure		channel1
	move.b	#1,d1					;Voie1		
	bsr	decode2
	move.w	tps1,d7					;D7=tps1	


cont_12:
	sub.b	#1,duree3
	cmp.b	#0,duree3				;Si duree3!=0 va cont_1
	bne	cont_32

	cmp.b	#255,(a3)				;Si channel3=255 Fin
	beq	fin2
	clr.l	d0					;Efface Int1 sav
	move.b	(a3)+,d0				;Frquence	channel3
	move.b	(a3)+,d2				;Dure		channel3
	move.b	#3,d1					;Voie3
	bsr	decode2
	move.w	tps3,d5

	btst	#1,($60000E)				;Si fil blanc=1 plus1
	bne	plus12	
	bclr	#0,($60000E)				;Vide couteur gauche
	bra	cont_32					;Va  cont_1

plus12:
	bset	#0,($60000E)				;Initialize couteur gauche


cont_32:
	sub.b	#1,duree2				
	cmp.b	#0,duree2				;Si duree2!=0 va cont_2
	bne	cont_42					

	cmp.b	#255,(a2)				;Si channel2=255 Fin
	beq	fin2					
	clr.l	d0					;Efface Int1 sav
	move.b	(a2)+,d0				;Frquence	channel2
	move.b	(a2)+,d2				;Dure		channel2
	move.b	#2,d1					;Voie2
	bsr	decode2
	move.w	tps2,d6					;D6=tps2
	
cont_42:

	sub.b	#1,duree4
	cmp.b	#0,duree4				;Si duree4!=0 va cont_4
	bne	fin_cont2
	
	cmp.b	#255,(a4)				;Si channel4=255 fin
	beq	fin2
	clr.l	d0					;Efface Int1 sav
	move.b	(a4)+,d0				;Frquence	channel4
	move.b	(a4)+,d2				;Dure		channel4
	move.b	#4,d1					;Voie4
	bsr	decode2
	move.w	tps4,d4					;D5=tps4


	btst	#0,($60000E)
	bne	plus22			
	bclr	#1,($60000E)
	bra	fin_cont2

plus22:
	bset	#1,($60000E)				;Initialize couteur droit
	


fin_cont2:
	
	move.w	unittps,d3				;D4=Tempo
	
;cas d'une pause
	cmp.w	tps1,d3					;Si tps1>Tempo alors paspause1
	bhi	paspause12
	move.w	tps1,d7					;D7=tps1

paspause12:
	cmp.w	tps2,d3					;Si tps2>Tempo alors paspause2 
	bhi	paspause22
	move.w	tps2,d6					;D6=tps2

paspause22:
	cmp.w	tps3,d3					;Si tps3>Tempo alors paspause3 		
	bhi	paspause32
	move.w	tps3,d5					;D5=tps3
	
paspause32:
	cmp.w	tps4,d3					;Si tps4>Tempo alors paspause4 
	bhi	paspause42
	move.w	tps4,d4					;D4=tps4
	
paspause42:


;-----------------------------------------	
;joue le son pendant une dure lmentaire
bcle_son2:
	dbra.w	d7,son_12
	move.w	tps1,d7
	bchg	#0,($60000E)

son_12:
	dbra.w	d6,son_22
	move.w	tps2,d6
	bchg	#1,($60000E)

son_22:
	dbra.w	d5,son_32
	move.w	tps3,d5
	bchg	#0,($60000E)
	
son_32:
	dbra.w	d4,son_42
	move.w	tps4,d4
	bchg	#1,($60000E)

son_42:
	dbra	d3,bcle_son2
	bra	boucle2
	

fin2:
	bclr	#0,($60000E)
	bclr	#1,($60000E)
	move.b	#$8D,($60000C)
	
	;move.w	(sp)+,d0
	;trap	#1
	movem.l	(a7)+,d0/d1/d3-d7/a0/a5
	rts
	
;******************************************************************
;Decode une valeur de note
;------------------------------------------------------------------
;d0=valeur code (1er chiffre hexa=octave,2me=note)
;d1=voie (1 ou 2)
;d2=dure
; =>d0=frquence
;******************************************************************

decode2:
	move.l	d1,-(a7)
	cmp.w	#0,d0
	beq	_pause2
	
	move.l	d0,d1
	ror.l	#4,d1
	
	sub.w	#1,d1
	mulu.w	#12,d1
	and.w	#$0f,d0
	sub.w	#1,d0
	add.w	d1,d0
	
	rol.l	#1,d0
	move.l	a0,a5
	
	add.w	d0,a5
	clr.l	d0
	move.w	(a5),d0
	bra	voie

_pause2:
	move.w	unittps,d0
	add.w	#1,d0

voie:
	move.l	(a7)+,d1
	cmp.b	#1,d1
	beq	voie1
	
	cmp.b	#2,d1
	beq 	voie2
	
	cmp.b	#3,d1
	beq	voie3
	bne	voie4
	
voie1:	move.w	d0,tps1
	move.b	d2,duree1
	rts

voie2:	move.w	d0,tps2
	move.b	d2,duree2
	rts
	
voie3:	move.w	d0,tps3
	move.b	d2,duree3
	rts

voie4:	move.w	d0,tps4
	move.b	d2,duree4
	rts

;********************************************
;Fin de PolySnd2 Play4Channel
;********************************************

;----------------------------
;Detection de la calculatrice
;----------------------------
GetCalculator:
	movem.l	a1,-(a7)			;Sauvegarde a1
	move.l $C8,a0				;Addresse pour vrifier si TI-89 ou TI-92 Plus
	move.b	#1,calc				;Prdfinis comme TI-92 Plus
	move.l	a0,d1				;Prpare d1
	and.l #$400000,d1			;Si ~0 alors TI-92 Plus sinon TI-89 ou V200
	bne	__calculator			;Dans cas TI-92 Plus alors Fin
	move.b	#0,calc				;Prdfinis comme TI-89
	move.l $2F*4(a0),a1			;Prpare condition
	cmp.b	#200,2(a1)			;Si 200 alors TI-89
	bcs	__calculator			;Donc Fin
	move.b	#2,calc				;Donc V200
__calculator:
	movem.l	(a7)+,a1			;Restaure a1
	rts
	
;-------------------------------------
;Detection de la version de l'Hardware
;-------------------------------------
GetHardware:
	move.l	$C8,d0
	and.l	#$600000,d0
	move.l	d0,a0
	move.l	$104(a0),a0
	move.w	#1,Hardware
	sub.l	a0,d0
	cmp.l	#-$10000,d0
	bls.b	__hardware
	cmp.w	#$16,(a0)
	bls.b	__hardware
	;move.l	#16(a0),Hardware
	move.w	#2,Hardware
__hardware:
	rts

;--------------------------------------------
;Masque pour la lecture du clavier	
;********************************************
;********************************************
;masque une ligne du clavier
;--------------------------------------------
;d0=ligne -> d0=rponse
;********************************************
masque:
	movem.l	d1,-(a7)
	move.w	#$FFFE,d1
	rol.w	d0,d1
	clr.w	d0
	move.w	d1,($600018)
	nop
	nop
	nop
	nop
	nop
	nop
	move.b	($60001B),d0
	movem.l	(a7)+,d1
	RTS
	
;----------------------------------------------------------------------------
;Donnes pour la libraire PolySnd
;----------------------------------------------------------------------------
	
TblFreq: dc.w	$011,$012,$013,$014,$015,$016,$017,$019,$01a,$01c,$01d,$01f
	 dc.w   $021,$023,$025,$027,$029,$02c,$02e,$031,$034,$037,$03a,$03e
	 dc.w   $041,$045,$049,$04e,$052,$057,$05c,$062,$068,$06e,$075,$07b
	 dc.w   $083,$08b,$093,$09c,$0a5,$0af,$0b9,$0c4,$0d0,$0dc,$0e9,$0f7
	 dc.w   $106,$115,$126,$137,$14a,$15d,$172,$188,$19f,$1b8,$1d2,$1ee
	 dc.w   $20b,$22a,$24b,$26e,$293,$2ba,$2e4,$310,$33f,$370,$3a4,$3dc
	 dc.w   $417,$455,$497,$4dd,$527,$575,$5c8,$620,$67d,$6e0,$749,$7b8
	 dc.w   $82d,$8a9,$92d,$9b9,$a4d,$aea,$b90,$c40,$cfa,$dc0,$e91,$f6f	
	 EVEN
	
duree1	dc.b	$0
	EVEN
duree2	dc.b	$0
	EVEN
duree3	dc.b	$0
	EVEN
duree4	dc.b	$0
	EVEN
tps1	dc.w	$0
	EVEN
tps2	dc.w	$0
	EVEN
tps3	dc.w	$0
	EVEN
tps4	dc.w	$0
	EVEN
	
unittps	dc.w	$0
	EVEN
	
calc	dc.b	0
	EVEN
Hardware dc.w	0
	EVEN
	end